`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:30:20 05/29/2016 
// Design Name: 
// Module Name:    LFSR 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module LFSR(
	 output reg dealt, 
    output reg [3:0] A,
	 input deal,
    input clk,
    input rst_n
    );
	 
	 reg [3:0] A_next;
	 reg [1:0] state,state_next;
	 reg dealt_next;
	 reg[3:0] counter,counter_next;
	 
always@*
	begin
		counter_next = counter;
		dealt_next = dealt;
		state_next = state;
		A_next[0] <= A[0];
		A_next[1] <= A[1];
		A_next[2] <= A[2];
		A_next[3] <= A[3];
		case(state)
			2'd0:
			begin
				dealt_next = 1'b0;
				if(A[2] & !A[3] || !A[2] & A[3])
					A_next[0] <= 1'b1;
				else 
					A_next[0] <= 1'b0;
					
					A_next[1] <= A[0];
					A_next[2] <= A[1];
					A_next[3] <= A[2];			//LFSR
				if(deal)		//NOTE deal signal needs debouncing
					begin		// aka stable signal
					state_next = 1'b1;
					end
			end
	
			2'd1:
				if(A < 4'd13)
					begin
						state_next = 2'd2;
						dealt_next = 1'b1;
					end
				else
					begin
						state_next = 1'b0;
						dealt_next = 1'b0;
					end
			2'd2:
				if(counter > 4'd15)	begin
					counter_next = 4'd0;
					state_next = 2'd0;
					dealt_next = 1'b0;
				end
				else 
					counter_next = counter + 1'b1;
			endcase
	end
						
always@(posedge clk or negedge rst_n)
	if(~rst_n)	begin
		A = 4'b1010;
		state = 1'b0;
		dealt = 1'b0;
		counter = 13'd0;
	end
	else	begin
		A = A_next;
		state = state_next;
		dealt = dealt_next;
		counter = counter_next;
	end
endmodule
